var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { useAsync } from './useAsync';
import { useSharedPromise } from './useSharedPromise';
import { usePromise } from './usePromise';
/**
 * Same to useAsync() but when calling concurrently the task will behave same
 * as useSharedPromise(). Eg.: the call will be joint if the arguments are the
 * same or will throw if arguments have changed.
 */
export function useSharedAsync(fn) {
    var _a = useAsync(fn), oldRunAsync = _a.runAsync, oldRun = _a.run, rest = __rest(_a, ["runAsync", "run"]);
    var runAsync = useSharedPromise(oldRunAsync);
    var run = usePromise(runAsync);
    return __assign(__assign({}, rest), { runAsync: runAsync, run: run });
}
