export function resolveHookAction(action) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    return typeof action === 'function' ? action.apply(void 0, args) : action;
}
/**
 * Compares two arrays to contain the same values (according to Object.is)
 */
export function areArgsEqual(a, b) {
    if (Array.isArray(a) && Array.isArray(b)) {
        for (var i = 0; i < a.length && i < b.length; i++) {
            if (!Object.is(a[i], b[i])) {
                return false;
            }
        }
        return true;
    }
    else {
        return Object.is(a, b);
    }
}
